function []=Meff_Bonf_correction
%%% Multiple Comparison
%%%   Not corrected
%%%   Bonferroni
%%%   Meff Method
%%%   Original by T.Sano 2013.12
%%%   Revised by M.Uga 2014.12

%%% Path setting
addpath([cd,'\from_spm8'])

p_th=[];
parameter_setting;

g_name=input('Please type group name\n','s');

%%% import data
cd('data');
[filename, pathname]=uigetfile('.csv','summary results files');
data=csvread([pathname,'\',filename]);
beta=data';
cd ..;

nch=size(beta,1);

[H,P,CI,STATS] = ttest(data);
t_value_list = STATS.tstat;

%%%%%%%%%%%%%%%%%%%%%
% t-values map (all channels)
% create map data
if flag_figure == 1
    [n, m]=size(ch_posi);
    T_map = zeros(n,m);
    for i=1:n
        for j=1:m
            if ch_posi(i,j)==0
                T_map(i,j)=0;
            else
                T_map(i,j)=t_value_list(ch_posi(i,j));
            end
        end
    end
    % show map
    figure
    imagesc(T_map);
    axis off
    axis image
    hc = colorbar;
    set(hc, 'FontSize', 8);
    saveas(gcf,[cd,'\figure\',g_name,'_group_tmap'],'emf');
end
%%%%%%%%%%%%%%%%%%%%%

FWEres.p_th=p_th
%%% Multiple comparison
beta_eig_abs=real(eig(corrcoef(beta')));
beta_eig=sort(beta_eig_abs,'descend');
FWEres.m_meff(1)=real(((sum(sqrt(beta_eig)))^2)/sum(beta_eig));
for i=1:nch
    [H, P, CI, status]=ttest(beta(i,:),0,0.05,'right');
    FWEres.t(1,i)=status.tstat;
end

i=1;
for p=p_th(1:end)
    FWEres.t_th_norm(i,1)=spm_invTcdf(1-(p),size(beta,2)-1);
    FWEres.t_th_bonf(i,1)=spm_invTcdf(1-(p/nch),size(beta,2)-1);
    FWEres.t_th_meff(i,1)=spm_invTcdf(1-(p/FWEres.m_meff(1)),size(beta,2)-1);
    FWEres.anum_norm(i,1)=size(find(FWEres.t(1,:)>spm_invTcdf(1-(p),size(beta,2)-1)),2);
    FWEres.anum_bonf(i,1)=size(find(FWEres.t(1,:)>spm_invTcdf(1-(p/nch),size(beta,2)-1)),2);
    FWEres.anum_meff(i,1)=size(find(FWEres.t(1,:)>spm_invTcdf(1-(p/FWEres.m_meff(1)),size(beta,2)-1)),2);
    i=i+1;
end

save([cd,'\result\',g_name,'_FWE.mat'],'FWEres');


%%%%%%%%%%%%%%%%%%%%%
% t-values map
if flag_figure == 1
    % t-values map of significant channels
    p = p_for_figure;

    % normal
    % create map data
    for i=1:n
        for j=1:m
            if ch_posi(i,j)==0
                T_map(i,j)=0;
            else
                if t_value_list(ch_posi(i,j))>=spm_invTcdf(1-(p),size(beta,2)-1);
                    T_map(i,j)=t_value_list(ch_posi(i,j));
                else
                    T_map(i,j)=0;
                end
            end
        end
    end
    % show map
    figure
    imagesc(T_map);
    axis off
    axis image
    hc = colorbar;
    set(hc, 'FontSize', 8);
    saveas(gcf,[cd,'\figure\',g_name,'_group_tmap_Norm'],'emf');

    % bonferroni
    % create map data
    for i=1:n
        for j=1:m
            if ch_posi(i,j)==0
                T_map(i,j)=0;
            else
                if t_value_list(ch_posi(i,j))>=spm_invTcdf(1-(p/nch),size(beta,2)-1);
                    T_map(i,j)=t_value_list(ch_posi(i,j));
                else
                    T_map(i,j)=0;
                end
            end
        end
    end
    figure
    imagesc(T_map);
    axis off
    axis image
    hc = colorbar;
    set(hc, 'FontSize', 8);
    saveas(gcf,[cd,'\figure\',g_name,'_group_tmap_Bonf'],'emf');

    % Meff
    % create map data
    for i=1:n
        for j=1:m
            if ch_posi(i,j)==0
                T_map(i,j)=0;
            else
                if t_value_list(ch_posi(i,j))>=spm_invTcdf(1-(p/FWEres.m_meff(1)),size(beta,2)-1);
                    T_map(i,j)=t_value_list(ch_posi(i,j));
                else
                    T_map(i,j)=0;
                end
            end
        end
    end
    figure
    imagesc(T_map);
    axis off
    axis image
    hc = colorbar;
    set(hc, 'FontSize', 8);
    saveas(gcf,[cd,'\figure\',g_name,'_group_tmap_Meff'],'emf');
end
%%%%%%%%%%%%%%%%%%%%%
 
%%%Path removing
rmpath([cd,'\from_spm8'])

